// Lab 4 - Two-Level Logic Minimization
// Vineet Jain 990932997
// Maziar Jalili 991372297
// Station #28
// March 29, 2004

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#define MAXDEGREESIZE 20 
#define INFINITY 23000

typedef
  struct cubestruct {
    char cube[MAXDEGREESIZE];
    int  size;
    struct cubestruct *link;
   } cubeType, *cubePtr;

typedef
  struct headstruct {
    cubeType *head;
    int      degree;
   } headType, *headPtr;

int cubeCompare(char cube1[], char cube2[]);
int sizeOfCube(char tempCube[]);
int addCube(cubeType *newcube, headType *list);
int insertCube(cubeType **head, cubeType *newCubeNode);
int lengthOfList(headType *list);
int isNotRedundant(char cube1[], char cube2[]);
int equalCover(headType *A, headType *B);
int isEssential(cubeType *a, headType *list, headType *dc);
int costOfCover(headType *A);
int isCover(headType *on, headType *test);
int dealloc(cubeType *tempPtr);

cubeType * alloc(char tempCube[]);

headType *createHead(int degree1);
headType *sharpOperation(headType *list, char cube2[]);
headType *createGI(headType *head1);
headType *merge(headType *A, headType *B);
headType *getInput(headType **c0, headType **dc);
headType *FindPrime(headType **pi, headType **dc);
headType *FindEssential(headType *pi, headType *dc);
headType *copyList(headType *A);
headType *FindCover(headType *epi, headType *pi, int *minsize, headType *on);
headType *FindCover2(headType *epi, headType *pi, int *minsize, headType *on, int howDeep);


void starOperation(char cube1[], char cube2[], char newCube[]);
void GetRidOfEssential(headType *epi, headType *pi);
void deleteCube(cubeType *del, headType *list);
void printCover(headType *A);
void destroyWholeList(headType *list);

char name[255];
int  howBig;

void
printSet(headType *A)
 {
  cubeType *now;

  if (A == NULL)
    return;

  now = A->head;

  printf("{ ");

  while (now != NULL)
   {
    printf("%s ",now->cube);
    now = now->link;
   }

  printf("}\n");

 }

//Makes the main function calls for finding prime implicants
//essential prime implicants and cover

int
main()
 {
  headType *pi=NULL;
  headType *dc=NULL;
  headType *epi=NULL;
  headType *cover=NULL;
  headType *on;
  int temp;

  on = FindPrime(&pi,&dc);
  if (on == NULL)
    return(0);

  printf("Prime Implicants: ");
  printSet(pi);

  epi = FindEssential(pi,dc);

  printf("Essential Prime Implicants:");
  printSet(epi);

  GetRidOfEssential(epi,pi);

  if (howBig <= 5)
    cover = FindCover(epi,pi,&temp,on);
  else
   {
    cover = FindCover2(epi,pi,&temp,on,0);
      printf("before if statement\n");
      if (temp==INFINITY){
      printf("before the merge\n");
        cover = merge(epi,pi);
      }
   }


  printf("Cover: ");
  printSet(cover);

  destroyWholeList(pi);
  destroyWholeList(epi);
  destroyWholeList(cover);
  destroyWholeList(on);
  return(0);
 }

//This function generates a list of prime implicants

headType *
FindPrime(headType **pi, headType **dc)
 {
  headType *on=NULL;
  headType *cI=NULL;
  headType *dc1=NULL;
  headType *gI1=NULL;
  headType *cI1=NULL;
  int finished = 0;
  int number;

  on = getInput(&cI,&dc1);
  if (on == NULL)
    return(NULL);
printf("cI: \n");
  printSet(cI);
  if (howBig <= 10)
   {
    while (finished == 0)
     {
      gI1 = createGI(cI);

      cI1 = merge(cI,gI1);

      destroyWholeList(gI1);

      if (equalCover(cI1,cI))
        finished = 1;
      else
       {
        destroyWholeList(cI);
        cI = cI1;
       }
     }
   }
  else
   {
    number = 0;
    while ((finished == 0) && (number < 10))
     {
      number++;
      gI1 = createGI(cI);

      cI1 = merge(cI,gI1);

      destroyWholeList(gI1);

      if (equalCover(cI1,cI))
        finished = 1;
      else
       {
        destroyWholeList(cI);
        cI = cI1;
       }
     }
   }
  printf("on: \n");
  printSet(on);
  printf("cI: \n");
  printSet(cI);
  printf("dc1: \n");
  printSet(dc1);
  //printf("gI1:
 
  *pi = cI;
  *dc = dc1;
  return(on);
 }

//----------------------------------------------------------------

headType *
FindEssential(headType *pi, headType *dc)
 {
  headType *epi=NULL;
  cubeType *current=pi->head;
  cubeType *newCubeNode=NULL;
  int      essential;

  epi  = createHead(pi->degree);

  while (current != NULL)
   {

    essential = isEssential(current,pi,dc);
    if (essential)
     {
      newCubeNode = alloc(current->cube);
      addCube(newCubeNode,epi);
     }
    current = current -> link;

   }

  return(epi);
 }

//----------------------------------------------------------------------------

void
GetRidOfEssential(headType *epi, headType *pi)
 {
  headType *nepi;
  cubeType *current2;
  cubeType *current;
  cubeType *previous;
  int found;

  if ((epi == NULL) || (epi->head == NULL) || (pi == NULL) || (pi->head == NULL))
    return;

  current2 = epi->head;

  while (current2 != NULL)
   {
    current = pi->head;
    previous = current;
    found = 0;

    while ((current != NULL) && (found == 0))
     {
      if (cubeCompare(current->cube, current2->cube) == 0)
       {
        if (previous == current)
         {
          pi->head = current->link;
          current -> link = NULL;
          dealloc(current);
          found = 1;
         }
        else
         {
          previous -> link = current -> link;
          current -> link = NULL;
          dealloc(current);
          found = 1;
         }
       }
      previous = current;
      current = current -> link;
     }

    current2 = current2 -> link;
   }
 }

//-------------------------------------------------------

headType *
FindCover(headType *epi, headType *pi, int *minsize, headType *on)
 {
  headType *epi2;
  headType *pi2;
  headType *epi3;
  headType *pi3;
  cubeType *current;
  cubeType *newNode;
  headType *aCover;
  headType *bCover;
  headType *minCover;
  int delme;
  int a;
  int b;

  a = isCover(on,epi);

  if (((pi == NULL) || (pi->head == NULL)) && (a == 0))
   {
    *minsize = INFINITY;
    return(NULL);
   }
  else if (a == 1)
   {
    minCover = copyList(epi);
    *minsize = costOfCover(epi);
    return(minCover);
   }
  else
   {
    current = pi->head;
    *minsize = INFINITY;

    epi2 = copyList(epi);

    pi2 = copyList(pi);

    epi3 = copyList(epi);

    pi3 = copyList(pi);

    newNode = alloc(current->cube);
    addCube(newNode,epi2);
    deleteCube(newNode,pi2);
    deleteCube(newNode,pi3);

    aCover = FindCover(epi2,pi2,&a,on);
    bCover = FindCover(epi3,pi3,&b,on);

    if (a < b)
     {
      if (a < *minsize)
       {
        *minsize = a;
        minCover = aCover;
       }
     }
    else
     {
      if (b < *minsize)
       {
        *minsize = b;
        minCover = bCover;
       }
     }
    destroyWholeList(epi2);
    destroyWholeList(pi2);
    destroyWholeList(epi3);
    destroyWholeList(pi3);
    return(minCover);
   }
 }

//------------------------------------------------------

headType *
FindCover2(headType *epi, headType *pi, int *minsize, headType *on, int howDeep)
 {
  headType *epi2;
  headType *pi2;
  headType *epi3;
  headType *pi3;
  cubeType *current;
  cubeType *newNode;
  headType *aCover;
  headType *bCover;
  headType *minCover;
  int delme;
  int a;
  int b;

  a = isCover(on,epi);

  if (howDeep > 7)
   {
    *minsize = INFINITY;
    return(NULL);
   }
  else if (((pi == NULL) || (pi->head == NULL)) && (a == 0))
   {
    *minsize = INFINITY;
    return(NULL);
   }
  else if (a == 1)
   {
    minCover = copyList(epi);
    *minsize = costOfCover(epi);
    return(minCover);
   }
  else
   {
    current = pi->head;
    *minsize = INFINITY;

    epi2 = copyList(epi);

    pi2 = copyList(pi);

    epi3 = copyList(epi);

    pi3 = copyList(pi);

    newNode = alloc(current->cube);
    addCube(newNode,epi2);
    deleteCube(newNode,pi2);
    deleteCube(newNode,pi3);

    aCover = FindCover2(epi2,pi2,&a,on,howDeep + 1);
    bCover = FindCover2(epi3,pi3,&b,on,howDeep + 1);

    if (a < b)
     {
      if (a < *minsize)
       {
        *minsize = a;
        minCover = aCover;
       }
     }
    else
     {
      if (b < *minsize)
       {
        *minsize = b;
        minCover = bCover;
       }
     }

    destroyWholeList(epi2);
    destroyWholeList(pi2);
    destroyWholeList(epi3);
    destroyWholeList(pi3);

    return(minCover);
   }
 }


//-------------------------------------------------------
//-------------------------------------------------------


headType *
getInput(headType **c0, headType **dc)
 {
  int check;
  char tempCube[MAXDEGREESIZE];
  char temp[255];
  char dcOrNot;
  cubeType *newCubeNode;
  cubeType *newCubeNode2;
  headType *on;
  
  //check first line: .names x1 .. xN f
  gets(name);
  check = sscanf(name,"%s",temp);
  if ((check == EOF) || (temp[0] != '.'))
   {
    printf("\nIncorrect Input\n");
    return(NULL);
   }


  (*c0) = createHead(0);
  (*dc) = createHead(0);
  on    = createHead(0);

  gets(temp);
  check = sscanf(temp,"%s %c %c", tempCube,&dcOrNot,&dcOrNot);

  if (check == EOF)
    return(NULL);

  if (dcOrNot == '1')
   {
    newCubeNode = alloc(tempCube);
    check = addCube(newCubeNode,*c0);
    if (check == 0)
     {
      newCubeNode2 = alloc(tempCube);
      addCube(newCubeNode2,on);
     }
   }
  else
   {
    newCubeNode = alloc(tempCube);
    check = addCube(newCubeNode,*c0);
    if (check == 0)
     {
      newCubeNode2 = alloc(tempCube);
      addCube(newCubeNode2,*dc);
     }
   }

  on   ->degree = strlen(tempCube);
  (*c0)->degree = on->degree;
  (*dc)->degree = on->degree;

  howBig = on->degree;

  while(1)
   {
    gets(temp);
    check = sscanf(temp,"%s %c %c", tempCube,&dcOrNot,&dcOrNot);
    if (check == EOF)
      break;

    if (strlen(tempCube) != (*c0)->degree)
      continue;
    else
     {
      if (dcOrNot == '1')
       {
        newCubeNode = alloc(tempCube);
        check = addCube(newCubeNode,*c0);
        if (check == 0)
         {
          newCubeNode2 = alloc(tempCube);
          addCube(newCubeNode2,on);
         }
       }
      else
       {
        newCubeNode = alloc(tempCube);
        check = addCube(newCubeNode,*c0);
        if (check == 0)
         {
          newCubeNode2 = alloc(tempCube);
          addCube(newCubeNode2,*dc);
         }
       }
     }
   }
  return(on);
 }


//This functions applies the star operation to find the prime implicants to 
//add to gI

headType *
createGI(headType *head1)
 {
  headType *gI = NULL;
  char tempCube[MAXDEGREESIZE];

  cubeType *current=head1->head;
  cubeType *next;
  cubeType *newCubeNode;

  gI = createHead(head1->degree);

  while (current != NULL)
   {
    next = current -> link;
    while (next != NULL)
     {
      starOperation(current->cube, next->cube,tempCube);
      if (tempCube[0] != '\0')
       {
        newCubeNode = alloc(tempCube);
        newCubeNode -> size = sizeOfCube(tempCube);
        addCube(newCubeNode,gI);
       }
      next = next -> link;
     }
    current = current -> link;
   }
  return(gI);
 }

//------------------------------------------------------

headType *
merge(headType *A, headType *B)
 {
  headType *C=NULL;
  cubeType *newCubeNode;
  cubeType *current1;
  cubeType *current2;
  cubeType *previous;
  int      add;

  C = createHead(A->degree);

  current1 = B->head;
  while (current1 != NULL)
   {
    add = 1;
    current2 = B->head;
    while (current2 != NULL)
     {
      if (cubeCompare(current1 -> cube , current2 -> cube) != 0)
        add = add && isNotRedundant(current1->cube,current2->cube);
      current2 = current2 -> link;
     }

    current2 = A->head;
    while (current2 != NULL)
     {
      if (cubeCompare(current1 -> cube , current2 -> cube) != 0)
        add = add && isNotRedundant(current1->cube,current2->cube);
      current2 = current2 -> link;
     }

    if (add == 1)
     {
      newCubeNode = alloc(current1->cube);
      addCube(newCubeNode,C);
     }
    current1 = current1->link;
   }

  current1 = A->head;
  while (current1 != NULL)
   {
    add = 1;
    current2 = A->head;
    while (current2 != NULL)
     {
      if (cubeCompare(current1 -> cube , current2 -> cube) != 0)
        add = add && isNotRedundant(current1->cube,current2->cube);
      current2 = current2 -> link;
     }

    current2 = B->head;
    while (current2 != NULL)
     {
      if (cubeCompare(current1 -> cube , current2 -> cube) != 0)
        add = add && isNotRedundant(current1->cube,current2->cube);
      current2 = current2 -> link;
     }

    if (add == 1)
     {
      newCubeNode = alloc(current1->cube);
      addCube(newCubeNode,C);
     }
    current1 = current1->link;
   }

  return(C);
 }

//--------------------------------------------------


int
equalCover(headType *A, headType *B)
 {
  cubeType *A1;
  cubeType *B1;
  int equal=1;

  if (lengthOfList(A) != lengthOfList(B))
    return(0);
  else
   {
    A1 = A->head;
    B1 = B->head;

    while ((A1 != NULL) && (equal == 1))
     {
      if (strcmp(A1->cube, B1->cube) == 0)
       {
        A1 = A1->link;
        B1 = B1->link;
       }
      else
        equal = 0;
     }
    return(equal);
   }
 }

//

void
starOperation(char cube1[], char cube2[], char newCube[])
 {
  int  i=0;
  int  noOfNULLS=0;
  int  finished=0;

  while (cube1[i] != '\0')
   {
    if (cube1[i] == cube2[i])
      newCube[i] = cube1[i];
    else if (cube1[i] == 'x')
      newCube[i] = cube2[i];
    else if (cube2[i] == 'x')
      newCube[i] = cube1[i];
    else
     {
      newCube[i] = 'N';
      noOfNULLS++;
     }
    i++;
   }
  newCube[i] = '\0';

  if (noOfNULLS > 1)
   {
    newCube[0]='\0';
   }
  else if (noOfNULLS == 1)
   {
    i = 0;
    while ((newCube[i] != '\0') && (finished == 0))
     {
      if (newCube[i] == 'N')
       {
        newCube[i] = 'x';
        finished = 1;
       }
      i++;
     }
   }

  if ((sizeOfCube(newCube) < sizeOfCube(cube1)) && (sizeOfCube(newCube) < sizeOfCube(cube2)))
   {
    newCube[0] = '\0';
   }
 }

//--------------------------------------------------------------

int
isNotRedundant(char cube1[], char cube2[])
 {
  int  noOfEpsilon=0;
  int  length=strlen(cube1);
  int  i = 0;


  while (cube1[i] != '\0')
   {
    if (cube1[i] == cube2[i])
     {
      noOfEpsilon++;
     }
    else if (cube1[i] == '0')
     {
      if (cube2[i] != '1')
       {
        noOfEpsilon++;
       }
     }

    else if (cube1[i] == '1')
     {
      if (cube2[i] != '0')
       {
        noOfEpsilon++;
       }
     }
    i++;
   }


  if (noOfEpsilon == length)
    return(0);
  else
    return(1);
 }

//--------------------------------------------------------------------
//--------------------------------------------------------------------

int
isEssential(cubeType *a, headType *list, headType *dc)
 {

  headType *temp;
  cubeType *current;
  cubeType *b;

  b = alloc(a->cube);

  temp = createHead(list->degree);
  temp -> head = b;

  current = list -> head;

  while (current != NULL)
   {
    if (cubeCompare(a->cube,current->cube) != 0)
     {
      temp = sharpOperation(temp,current->cube);
     }
    current = current -> link;
   }

  current = dc->head;

  while (current != NULL)
   {
    temp = sharpOperation(temp,current->cube);
    current = current -> link;
   }

  if (temp->head == NULL)
    return(0);
  else
   {
    destroyWholeList(temp);
    return(1);
   }
 }

//----------------------------------------------------------------

headType *
sharpOperation(headType *list, char cube2[])
 {
  char newCube[MAXDEGREESIZE];
  char cube1[MAXDEGREESIZE];
  int  i=0;
  int  noOfNULLS=0;
  int  noOfEpsilon=0;
  int  length=strlen(cube2);
  int  finding;
  int  total;
  int  minus;
  cubeType *current=list->head;
  cubeType *newCubeNode=NULL;
  headType *newList=NULL;

  newList = createHead(list->degree);

  while (current != NULL)
   {
    i = 0;
    noOfEpsilon = 0;
    noOfNULLS = 0;
    strcpy(cube1,current -> cube);

    while (cube1[i] != '\0')
     {
      if (cube1[i] == cube2[i])
       {
        newCube[i] = 'E';
        noOfEpsilon++;
       }
      else if (cube1[i] == '0')
       {
        if (cube2[i] == '1')
         {
          newCube[i] = 'N';
          noOfNULLS++;
         }
        else
         {
          newCube[i] = 'E';
          noOfEpsilon++;
         }
       }

      else if (cube1[i] == '1')
       {
        if (cube2[i] == '0')
         {
          newCube[i] = 'N';
          noOfNULLS++;
         }
        else
         {
          newCube[i] = 'E';
          noOfEpsilon++;
         }
       }
      else if (cube1[i] == 'x')
       {
        if (cube2[i] == '0')
          newCube[i] = '1';
        else
          newCube[i] = '0';
       }
      i++;
     }

    newCube[i] = '\0';

    if (noOfEpsilon == length)
     {
      current = current->link;
      continue;
     }
    else if (noOfNULLS > 0)
     {
      newCubeNode = alloc(cube1);
      addCube(newCubeNode,newList);
     }
    else
     {
      total = 1;
      finding = 1;
      while(finding)
       {
        finding = 0;
        i = 0;
        minus = 0;
        while (cube1[i] != '\0')
         {
          if ((cube1[i] == 'x') && (cube2[i] == 'x'))
           {
            newCube[i] = 'x';
           }
          else if (cube1[i] == 'x')
           {
            minus++;
            if (minus == total)
             {
              finding = 1;
              if (cube2[i] == '1')
                newCube[i] = '0';
              else
                newCube[i] = '1';
             }

            else
              newCube[i] = 'x';
           }
          else
            newCube[i] = cube1[i];
          i++;
         }

        newCube[i] = '\0';
        if (finding == 1)
         {
          total++;
          newCubeNode = alloc(newCube);
          addCube(newCubeNode,newList);
         }
       }
     }
    current = current -> link;
   }
  destroyWholeList(list);
  return(newList);

 }

//--------------------------------------------------------------------
//--------------------------------------------------------------------

int
isCover(headType *on, headType *test)
 {
  headType *on2;
  headType *test2;
  cubeType *current;
  int      answer;

  on2 = copyList(on);

  test2 = copyList(test);

  current = test2->head;

  while (current != NULL)
   {
    on2 = sharpOperation(on2,current->cube);
    current = current->link;
   }

  if (on2->head == NULL)
    answer = 1;
  else
    answer = 0;

  destroyWholeList(on2);
  destroyWholeList(test2);
  return(answer);
 }

//--------------------------------------------------------------------

int
costOfCover(headType *A)
 {
  int sum=0;
  cubeType *current;

  if ((A == NULL) || (A->head == NULL))
    return(0);
  else if (A->head->link == NULL)
   {
    return(strlen(A->head->cube) + 1 - A->head->size);
   }
  else
   {
    current = A->head;
    while (current != NULL)
     {
      sum = sum + strlen(current->cube) - current->size + 2;
      current = current -> link;
     }

    return(sum + 1);
   }
 }

//--------------------------------------------------------------------
//--------------------------------------------------------------------

int
cubeCompare(char cube1[], char cube2[])
 {
  int i=0;
  // check new cube
  while (cube1[i] != '\0')
   {
    if (cube1[i] != cube2[i])
     {
      if (cube1[i] == 'x')
        return(-1);
      else if (cube2[i] == 'x')
        return(1);
      else if (cube1[i] == '0')
        return(-1);
      else
        return(1);
     }
    i++;
   }
  return(0);
 }

//------------------------------------------------------

int
sizeOfCube(char tempCube[])
 {
  int size=0;
  int i=0;

  while(tempCube[i] != '\0')
   {
    if (tempCube[i] == 'x')
      size++;
    i++;
   }
  return(size);
 }

//-----------------------------------------------------

cubeType *
alloc(char tempCube[])
 {
  cubeType *NewNode;

  NewNode = (cubePtr)malloc(sizeof(cubeType));
  if (NewNode == NULL)
   {
    printf("Error in Node Constuct");
   }
  else
   {
    strcpy(NewNode->cube,tempCube);
    NewNode->size = sizeOfCube(tempCube);
    NewNode->link = NULL;
   }

  return(NewNode);
 }

//---------------------------------------------------------

int
dealloc(cubeType *tempPtr)
 {
  if (tempPtr == NULL)
    return(-1);

  free(tempPtr);
  tempPtr = NULL;
  return(0);
 }

//---------------------------------------------------------

int
addCube(cubeType *newcube, headType *list)
 {
  int check;

  if ((list != NULL) && (newcube != NULL))
   {
    check = insertCube(&(list->head),newcube);
    return(check);
   }
  else
   {
    printf("\npd or list are NULL in addCube");
    return(-1);
   }
 }

//--------------------------------------------------------------------------

int
insertCube(cubeType **head, cubeType *newCubeNode)
 {

  cubeType *current = *head;
  cubeType *previous = *head;
  int found = 0;
  int compare;
  char newcube[MAXDEGREESIZE];

  strcpy(newcube,newCubeNode->cube);

  while ((current != NULL) && (found == 0))
   {
    compare = cubeCompare(newcube, current->cube);
    if (compare == 0)
     {
      return(-1);
     }
    if (compare == 1)
      found = 1;
    else
     {
      previous = current;
      current = current -> link;
     }
   }

  /* List is empty or node to be added is the first one */
  if (current == *head)
   {
    newCubeNode -> link = current;
    *head = newCubeNode;
   }

  /* List is not empty and node to be added is not the first */
  else
   {
    newCubeNode -> link = current;
    previous -> link = newCubeNode;
   }
  return(0);
 }

//------------------------------------------------------------------

headType *
createHead(int degree1)
 {
  headType *NewNode;


  NewNode = (headPtr)malloc(sizeof(headType));
  if (NewNode == NULL)
    printf("\nError in createHead");
  else
   {
    NewNode -> degree = degree1;
    NewNode -> head = NULL;
   }
  return(NewNode);
 }


//---------------------------------------------------------

int
lengthOfList(headType *list)
 {
  int length=0;
  cubeType *temp;

  if (list == NULL)
    return(-1);
  else
   {
    temp = list->head;
    while (temp != NULL)
     {
      length++;
      temp = temp->link;
     }
    return(length);
   }
 }

//---------------------------------------------------------

void
destroyWholeList(headType *list)
 {
  cubeType *A;

  while ((list)->head != NULL)
   {
    A = (list)->head;
    (list)->head = (list)->head->link;
    A->link=NULL;
    dealloc(A);
   }

  if (((list) -> head == NULL) && ((list) -> degree == 0))
   {
    list = NULL;
    return;
   }

  free(list);
  list=NULL;
 }

//------------------------------------------

void
printCover(headType *A)
 {
  cubeType *now;

  if (A == NULL)
    return;

  now = A->head;

 /* printf("\nCOVER\n%s\n",name);*/

  while (now != NULL)
   {
    printf("%s 1\n",now->cube);
    now = now->link;
   }
 }

//-------------------------------------------------------------------

headType *
copyList(headType *A)
 {
  headType *B;
  cubeType *newNode;
  cubeType *current;
  cubeType *add;

  if (A == NULL)
    return(NULL);

  B = createHead(A->degree);

  current = A->head;

  if (current != NULL)
   {
    newNode = alloc(current->cube);
    B->head = newNode;
    add = newNode;
    current = current -> link;
   }

  while (current != NULL)
   {
    newNode = alloc(current->cube);
    add->link = newNode;
    add = newNode;
    current = current -> link;
   }

  return(B);

 }

//-----------------------------------------------

void
deleteCube(cubeType *del, headType *list)
 {
  cubeType *current;
  cubeType *previous;

  current = list->head;
  previous = current;

  while ((cubeCompare(current -> cube ,del -> cube) != 0) && (current != NULL))
   {
    previous = current;
    current = current -> link;
   }

  if (previous == current)
   {
    list -> head = list ->head->link;
    current->link = NULL;
    dealloc(current);
   }
  else
   {
    previous -> link = current->link;
    current->link = NULL;
    dealloc(current);
   }
 }

//------------------------------------------------------
//------------------------------------------------------
