n=3
print """
// Array Multiplier. Licensed under the terms of the GNU GPL version 2.0 or
// higher.
module full_adder (x, y, cin, cout, sout, s);
    input x, y, cin;
    output s, cout, sout;
    assign cout = x&y | x&cin | y&cin;
    assign sout = y ^ cin;
    assign s = sout ^ x;
endmodule

module array_cell (ppiin, mj, mjn, plusi, minusi, cin, cout, sout, ppip1out);
    input ppiin, mj, mjn, plusi, minusi, cin;
    output cout, ppip1out, sout;
    wire z;
    assign z = (plusi & mj) | (minusi & mjn);
    full_adder fa (ppiin, z, cin, cout, sout, ppip1out);
endmodule

module booth_encoder (qim1, qi, plusi, minusi);
    input qim1, qi;
    output  plusi, minusi;
    assign plusi = qim1 & ~qi;
    assign minusi = ~qim1 & qi;
endmodule

module lab0(M,Q,P,pctrl,mctrl);
    input [%(n)i-1:0] M, Q;
    wire  [%(n)i:0] beIn;
    assign beIn[%(n)i:1] = Q[%(n)i-1:0];
    assign beIn[0] = 0;

    output [2*%(n)i-1:0] P;
    output [%(n)i-1:0]pctrl, mctrl;
""" % {'n':n}


for r in range(n):
    print \
"""        wire top_row%(r)i,sin_row%(r)i,dc_row%(r)i,s_row%(r)i,cout_row%(r)i;
        booth_encoder be_row%(r)i(beIn[%(r)i],beIn[%(r)i+1],pctrl[%(r)i],mctrl[%(r)i]); """ % {'r':r}
    for c in range(n):
        print \
"""          wire ppi_row%(r)i_col%(c)i, cin_row%(r)i_col%(c)i,
          cout_row%(r)i_col%(c)i, sout_row%(r)i_col%(c)i, ppo_row%(r)i_col%(c)i;
          array_cell ac_row%(r)i_col%(c)i(ppi_row%(r)i_col%(c)i,
                        M[%(c)i], ~M[%(c)i],
                        pctrl[%(r)i],mctrl[%(r)i],
                        cin_row%(r)i_col%(c)i,cout_row%(r)i_col%(c)i,
                        sout_row%(r)i_col%(c)i,ppo_row%(r)i_col%(c)i);""" \
                        % {'r':r,'c':c}
    print 
"""          full_adder fa_row%(r)i(top_row%(r)i,sin_row%(r)i,0,
                      cout_row%(r)i,dc_row%(r)i,s_row%(r)i);""" \
    % {'r':r}

for r in range(n):
    for c in range(n):
        if (r == 0):
            print \
"""        assign ppi_row%(r)i_col%(c)i = 0;""" % {'r':r,'c':c}
        elif (c != (n-1)):
            print \
"""        assign ppi_row%(r)i_col%(c)i = ppo_row%(rm1)i_col%(cp1)i; """ \
            % {'r':r,'c':c,'rm1':r-1,'cp1':c+1}
        elif (r == 1):
            print \
"""        assign ppi_row%(r)i_col%(c)i = sout_row%(rm1)i_col%(cp1)i;""" \
            %  {'r':r,'c':c,'rm1':r-1,'cp1':c}
    if (r == 2):
         print \
"""      assign top_row%(r)i = ~sout_row%(rm1)i_col%(nm1)i;
      assign sin_row%(r)i = ~sout_row%(r)i_col%(nm1)i;""" \
          % {'r':r,'c':c,'rm1':r-1,'nm1':n-1}
    elif (r > 2):
        print \
"""      assign sin_row%(r)i = ~sout_row%(r)i_col%(nm1)i;
      assign top_row%(r)i = cout_row%(rm1)i;
      assign ppi_row%(r)i_col%(nm1)i = s_row%(rm1)i;""" \
          % {'r':r,'c':c,'rm1':r-1,'nm1':n-1}
print "endmodule"
