module datapath ( sram_addr, sram_send, sram_read, sram_write, sram_recv,
                  pc_r0, incr, add_sub, read, write, clk,
                  pci, r0i, r1i, r2i, r3i, iri, zzi,
                  pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
                  ir, r0,r1,r2,r3, splice);
                  //temp, pc, r0, r1, r2, r3, ir, bus, alu_a, zz );

  input[15:0] sram_recv;
  input pc_r0, incr, add_sub, read, write, clk,
        pci, r0i, r1i, r2i, r3i, iri, zzi,
        pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
        splice;

  output[8:0] sram_addr;
  output[15:0] sram_send;
  output sram_read, sram_write;
//  output[15:0] zz, temp, pc, r0, r1, r2, r3, ir, bus, alu_a;
  output[15:0] ir, r0,r1,r2,r3;
        
  wire[15:0] temp, pc, r0, r1, r2, r3, ir, bus, alu_a;
  //wire[15:0] bus_sel[7:0]; //erm, this makes icarus happy but I think quartus
                       //will have a field day
  wire[8:0] addr;
  reg overflow;

  reg[15:0] zz;

  assign sram_addr = addr;
  assign sram_send = bus;

  //assign bus_sel = {zz,pc,r0,r1,r2,r3,ir,sram_recv}; //and hope to hell this works
  assign addr = pc_r0 ? {0,pc[7:0]} : {1,r0[7:0]};
/*
  lpm_ff addrr(.clock(clk),.data(addr),.q(sram_addr));
  defparam addrr.LPM_AVALUE=0, addrr.LPM_WIDTH=9;
  lpm_ff datar(.clock(clk),.data(bus),.q(sram_send));
  defparam datar.LPM_AVALUE=0, datar.LPM_WIDTH=16;*/
  lpm_ff srr(.clock(clk),.data(read),.q(sram_read));
  defparam srr.LPM_AVALUE=0, srr.LPM_WIDTH=1;
  lpm_ff swr(.clock(clk),.data(write),.q(sram_write));
  defparam swr.LPM_AVALUE=0, swr.LPM_WIDTH=1;

  //lpm_ff zzr(.clock(clk),.data(alu_out),.q(zz));
  //defparam zzr.LPM_AVALUE=0, zzr.LPM_WIDTH=16;
  lpm_ff tempr(.clock(clk),.data(bus),.q(alu_a));
  defparam tempr.LPM_AVALUE=0, tempr.LPM_WIDTH=16;
  lpm_ff pcr(.clock(clk),.enable(pci),.data(bus),.q(pc));
  defparam pcr.LPM_AVALUE=0, pcr.LPM_WIDTH=16;
  lpm_ff r0r(.clock(clk),.enable(r0i),.data(bus),.q(r0));
  defparam r0r.LPM_AVALUE=0, r0r.LPM_WIDTH=16;
  lpm_ff r1r(.clock(clk),.enable(r1i),.data(bus),.q(r1));
  defparam r1r.LPM_AVALUE=0, r1r.LPM_WIDTH=16;
  lpm_ff r2r(.clock(clk),.enable(r2i),.data(bus),.q(r2));
  defparam r2r.LPM_AVALUE=0, r2r.LPM_WIDTH=16;
  lpm_ff r3r(.clock(clk),.enable(r3i),.data(bus),.q(r3));
  defparam r3r.LPM_AVALUE=0, r3r.LPM_WIDTH=16;
  lpm_ff irr(.clock(clk),.enable(iri),.data(bus),.q(ir));
  defparam irr.LPM_AVALUE=0, irr.LPM_WIDTH=16;

  encandmux eam(pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
                pc, ir, zz, r0, r1, r2, r3, sram_recv, bus );

  always @(posedge clk)
    if (incr)
      {overflow,zz} = bus + 1;
    else if (add_sub)
      {overflow,zz} = bus + alu_a;
    else if (splice)
      {overflow,zz} = {0, bus[7:0]};
    else
      {overflow,zz} = bus - alu_a;

endmodule
