module proc (m68k_master, clk, address, data_in, data_out, sram_read, sram_write,
             m_r0, m_r1, m_r2, m_r3);
  parameter N = 16;
  input m68k_master;
  input clk;
  output [8:0] address;
  input [N-1:0] data_in;
  output [N-1:0]data_out;
  output sram_read;
  output sram_write;
  
  // m_r0, m_r1, m_r2, m_r3 are used for monitoring
  // the values of the 4 general purpose registers

  output [N-1:0] m_r0, m_r1, m_r2, m_r3;
  wire clk, m68k_master, cur, next,
       pc_r0, incr, add_sub, read, write,
       pci, r0i, r1i, r2i, r3i, iri, zzi,
       pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
       splice;

  wire[N-1:0] ir;
 
  control cc( ir, clk, m68k_master, cur, next,
              pc_r0, incr, add_sub, read, write,
              pci, r0i, r1i, r2i, r3i, iri, zzi,
              pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
              splice);
  
  datapath dp( address, data_out, sram_read, sram_write, data_in,
               pc_r0, incr, add_sub, read, write, clk,
               pci, r0i, r1i, r2i, r3i, iri, zzi,
               pco, iro, zzo, r0o, r1o, r2o, r3o, sramo,
               ir, m_r0,m_r1,m_r2,m_r3, splice);
endmodule
