module top (clk, m68k_master, /*m_r0, m_r1, m_r2, m_r3,*/ oaddress, osram_ad,
            oram_data_out, oram_data_in, oram_read, oram_write);

  input clk, m68k_master; 
/*  output [15:0] m_r0, m_r1, m_r2, m_r3;*/
  output [8:0] oaddress;
  output [4:0] osram_ad;
  output [15:0] oram_data_out, oram_data_in;
  output oram_read, oram_write;

  wire [8:0] address;
  wire [15:0] ram_data_out, ram_data_in;
  wire ram_read, ram_write;
  wire [4:0] sram_ad;
	
	
  
/************ end declaration ***************************/
  
   assign osram_ad = sram_ad,
          oram_data_out = ram_data_out,
          oram_data_in = ram_data_in,
          oaddress = address,
          oram_read = ram_read,
          oram_write = ram_write;

   assign sram_ad[3:0] = address[3:0],
          sram_ad[ 4 ] = address[ 8 ];

   
   proc P0 ( m68k_master, clk, address, ram_data_out, ram_data_in, 
             ram_read, ram_write, m_r0, m_r1, m_r2, m_r3); 

   lpm_ram_dq RAM ( .data(ram_data_in), .address(sram_ad), .we(ram_write),
                   .q(ram_data_out), .inclock (clk) );

      defparam RAM.lpm_width = 16, RAM.lpm_widthad = 5, RAM.lpm_file = "test.mif",
               RAM.lpm_indata = "REGISTERED", RAM.lpm_address_control = "REGISTERED",
               RAM.lpm_outdata = "UNREGISTERED";

   
 
endmodule
