module wrapper (address, data, codata, srama, sramdl, sramdh, codsync, codread,	codwrite,
	            sram1en, sram2en, sram1oe, sram2oe, sram1we, sram2we, sram1ud, sram2ud,
	            sram1ld, sram2ld, br_sfpga,	bg_sfpga, bgack_sfpga, clk, fc, berr, as, halt, reset,
	            dtack, lds,	uds, rw, irqsf,	iacksf, hex0, hex1, hex2, hex3, sfpga_digital,
	            sfpga_con40, sfpga_logic, sfpga_con60, led, pclk);

	// in your designs the following pins should be kept as inputs
	// or bidirectionals unless you intend to use them as outputs
	
	input [23:1] address;
	inout [15:0] data;
	input [31:0] codata;
	output [17:0] srama;
	inout [15:0] sramdl, sramdh;
	input codsync, codread,	codwrite;
	output sram1en,	sram2en;
	output sram1oe,	sram2oe;
	output sram1we,	sram2we;
	output sram1ud,	sram2ud;
	output sram1ld,	sram2ld;
	input br_sfpga,	bg_sfpga, bgack_sfpga,	clk;
	input [2:0] fc;
	input berr,	as,	halt, reset;
	inout dtack;
	input lds,	uds, rw, irqsf,	iacksf;
	output [7:0] hex0, hex1, hex2, hex3;
	input [33:0] sfpga_digital;
	input [31:0] sfpga_con40;
	input [17:0] sfpga_logic;
	input [51:0] sfpga_con60;
	output [15:0] led;
	input pclk;
  
    
  wire [15:0] proc_data_out;
  wire [15:0] proc_data_in;
  wire [8:0] proc_addr;
  wire proc_write, proc_read; 
  wire [15:0] m_r0, m_r1, m_r2, m_r3;
  wire m68k_master;

  assign m68k_master = 1; //sfpga_digital[0];
 
  proc PROC0 ( m68k_master, 
							 clk, proc_addr, proc_data_in, proc_data_out, 
               proc_read, proc_write, m_r0, m_r1, m_r2, m_r3 );

  sram SRAM0 ( m68k_master, 
							 srama, sramdl, sramdh, sram1en, sram2en, 
               sram1oe, sram2oe, 
							 sram1we, sram2we, sram1ud, sram2ud, sram1ld, sram2ld,
               address, as, rw, uds, lds, 
							 dtack, 
							 data, 
               proc_addr, proc_read, proc_write, proc_data_out, proc_data_in );

  assign led = ~ m_r3;

	assign hex0 = m68k_master ? 8'b1100_1111 : 8'b0,
 				 hex1 = 8'b0,
         hex2 = 8'b0,
         hex3 = 8'b0;
 
endmodule

