/* Reaction Timer */

#include <stdio.h>
/* Set pointers to point to registers */
char *sysr 	= (char *)0xFFFFFFFE;
char *imr 	= (char *)0xFFFFF7EB;
char *isr 	= (char *)0xFFFFF7EB;
char *ivr 	= (char *)0xFFFFF7F9;
char *cur 	= (char *)0xFFFFF7ED;
char *clr 	= (char *)0xFFFFF7EF;
char *stc 	= (char *)0xFFFFF7FD;
char *spc 	= (char *)0xFFFFF7FF;
char *csr 	= (char *)0xFFFFF7E3;
char *acr 	= (char *)0xFFFFF7E9;

char *pad 	= (char *)0xC10000;
char *pbd 	= (char *)0xC10001;
char *padir 	= (char *)0xC10002;
char *pbdir 	= (char *)0xC10003;
char *pa 	= (char *)0xC10004;

short *hex 	= (short *)0x00A00000;

int *int_addr = (int *)(0x100);
#define INT_VECT 64;
#define DELAY 2000000

extern int intrstub(void);
extern int spl0(void),spl7(void);
int rollover;

int main(void)
{
  char lights = 0x00;
  int ctr = DELAY;
  short int disp;
  rollover = 0;
  
  
  /* Configure PIT ports and counter */
  *acr = 0x90;
  *csr = 0xCC;
  *cur = 0xFF;
  *clr = 0xFF;

  *pbdir = 0xFF;
  *padir = 0x00;

  *pbd = lights;
  /* Configure interrupts */
  *sysr = 4;    	/* duart interrupts at level 4 */
  *ivr = INT_VECT;	/* Set duart vector 	*/
  *int_addr = (long)(intrstub); 
  
  /* Wait for GO switch */
  while (!(*pa & 0x01));

  /* Turning LED on after a period of time */
  /* Start counter */
  while (ctr--);
  *pbd = 0x3C;
  ctr = *stc;

  ctr = 0;
  /* Wait for user response and check for rollover */
  while (!(*pa & 0x02));
  *spc;
  *pbd = 0xC3;

  while (rollover--)
    ctr += 0xFFFF;

  /* Read counter */
  /* Calculate total count */
  /* Convert total count to hundredths of seconds */
  ctr += 0xFFFF - (*cur << 8 + *clr);
  ctr /= 129;

  /* Convert hundredths of seconds to decimal number */
  disp = ((ctr/1000 % 10) << 12) + ((ctr/100 % 10) << 8) + ((ctr/10 % 10) << 4) + (ctr % 10);

  /* Display the reaction time on the 7-segment display */
  *hex = disp;
}

/* Interrupt service routine when count rolls over */
int interrupt()
{
     /* Incrememnt rollover variable */
  rollover++;
}
